#include "Sequencer.h"
#include <iostream>

Sequencer::Sequencer()
    : launchpad(), playbackScreen(*this), messages(),
      defaultOutputChannel(9), player(&midiOut, &beats, *this)
{
    playbackScreen.setLaunchpad(launchpad);
    beats.resize(midi::Launchpad::width - 1);
}

void Sequencer::run()
{
    std::cout << __func__ << std::endl;

    midiOut.openVirtualPort("launchpad sequencer");

    messages.resize(5);
    for(int i=0; i<messages.size(); i++) {
        messages[i] = std::make_shared<midi::NoteOnMessage>(defaultOutputChannel, 20 + i * 12, 100 + i);
    }

    playbackScreen.enable(); 

    player.setBpm(600);

    std::cin.ignore();
}
